#pragma once

#include <iostream>
#include <fstream>
#include <string>

#include "Node.hpp"

using std::cin;
using std::cout;
using std::endl;

using std::ifstream;
using std::ofstream;
using std::fstream;

using std::string;

template <class T>
class BST
{
public:
	BST();

	void insert(const T &newData); 

private:
	Node<T>* mpRoot;

	// we're using the private version of insert to allow for procedural
	// abstraction for the public interface; we don't want to show
	// that we're using pointers for our design; someone using our
	// template doesn't need to know specifically how the tree was developed, just
	// that to insert you need to specify the data
	void insert(Node<T>* pTree, const T& newData);
};

template<class T>
inline BST<T>::BST()
{
	this->mpRoot = nullptr;
}

template<class T>
inline void BST<T>::insert(const T& newData)
{
	insert(this->mpRoot, newData);
}

template<class T>
inline void BST<T>::insert(Node<T>* pTree, const T& newData)
{
	// Node<T>* pMem = new Node (newData);
	if (pTree == nullptr)
	{
		// tree must be empty
		this->mpRoot = new Node<T>(newData);
	}
	else
	{
		// recursion
		if (newData < pTree->getData()) // we'll finish on Mon, Mar 4
		{
			// go left
			if (pTree->getLeftPtr() == nullptr)
			{
				pTree->setLeftPtr(new Node<T>(newData));
			}
			else
			{
				// recursive step - we have to go further down the tree - left subtree
				insert(pTree->getLeftPtr(), newData);
			}
		}
		else if (newData > pTree->getData())
		{
			// go right
			if (pTree->getRightPtr() == nullptr)
			{
				pTree->setRightPtr(new Node<T>(newData));
			}
			else
			{
				// recursive step - we have to go further down the tree - left subtree
				insert(pTree->getRightPtr(), newData);
			}
		}
		else
		{
			cout << "duplicate value: " << newData << endl;
		}
	}
}
